#include "myMath.h"


void diffVector (Vector v1, Vector v2, Vector res) {
	
	res[0] = v1[0] - v2[0];
	res[1] = v1[1] - v2[1];
	res[2] = v1[2] - v2[2];
	res[3] = 0.;
}


void normalizeVector (Vector v) {

	float norm = sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
	if (norm != 0.)
	{
		v[0] /= norm;
		v[1] /= norm;
		v[2] /= norm;
	}
}


void crossProductVector (Vector v1, Vector v2, Vector res) {

	res[0] = v1[1]*v2[2] - v1[2]*v2[1];
	res[1] = v1[2]*v2[0] - v1[0]*v2[2];
	res[2] = v1[0]*v2[1] - v1[1]*v2[0];
	res[3] = 0.;
}


void sumVector (Vector v1, Vector v2, Vector res) {

	res[0] = v1[0]+v2[0];
	res[1] = v1[1]+v2[1];
	res[2] = v1[2]+v2[2];
	res[3] = v1[3];
}


void multFloatVector (float a, Vector v, Vector res) {

	res[0] = a*v[0];
	res[1] = a*v[1];
	res[2] = a*v[2];
	res[3] = v[3];
}


void copyVector (Vector v, Vector res) {

	res[0] = v[0];
	res[1] = v[1];
	res[2] = v[2];
	res[3] = v[3];
}

